it-roy-ru.com

почему я получаю неинициализированную константу Devise name Error при запуске сервера webrick?

В моем приложении я использовал Ruby 1.9.2 и Rails 3.0.3, а также установил гем Devise. Проблема начинается, когда я запускаю сервер Webrick, я получаю неинициализированную константу Devise name Error ,.

       /home/app/Workspace/project/Library_Management/Library_Management/config/initializers/devise.rb:3:in `<top (required)>': uninitialized constant Devise (NameError)
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/engine.rb:201:in `block (2 levels) in <class:Engine>'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/engine.rb:200:in `each'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/engine.rb:200:in `block in <class:Engine>'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/initializable.rb:25:in `instance_exec'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/initializable.rb:25:in `run'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/initializable.rb:50:in `block in run_initializers'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/initializable.rb:49:in `each'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/initializable.rb:49:in `run_initializers'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/application.rb:134:in `initialize!'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/application.rb:77:in `method_missing'
from /home/app/Workspace/project/Library_Management/Library_Management/config/environment.rb:5:in `<top (required)>'
from /home/app/.rvm/rubies/Ruby-1.9.2-p180/lib/Ruby/site_Ruby/1.9.1/rubygems/custom_require.rb:54:in `require'
from /home/app/.rvm/rubies/Ruby-1.9.2-p180/lib/Ruby/site_Ruby/1.9.1/rubygems/custom_require.rb:54:in `require'
from /home/app/Workspace/project/Library_Management/Library_Management/config.ru:3:in `block in <main>'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/rack-1.2.3/lib/rack/builder.rb:46:in `instance_eval'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/rack-1.2.3/lib/rack/builder.rb:46:in `initialize'
from /home/app/Workspace/project/Library_Management/Library_Management/config.ru:1:in `new'
from /home/app/Workspace/project/Library_Management/Library_Management/config.ru:1:in `<main>'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/rack-1.2.3/lib/rack/builder.rb:35:in `eval'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/rack-1.2.3/lib/rack/builder.rb:35:in `parse_file'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/rack-1.2.3/lib/rack/server.rb:162:in `app'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/rack-1.2.3/lib/rack/server.rb:253:in `wrapped_app'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/rack-1.2.3/lib/rack/server.rb:204:in `start'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/commands/server.rb:65:in `start'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/commands.rb:30:in `block in <top (required)>'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/commands.rb:27:in `tap'
from /home/app/.rvm/gems/Ruby-1.9.2-p180/gems/railties-3.0.9/lib/Rails/commands.rb:27:in `<top (required)>'
from /home/app/.rvm/rubies/Ruby-1.9.2-p180/lib/Ruby/site_Ruby/1.9.1/rubygems/custom_require.rb:58:in `require'
from /home/app/.rvm/rubies/Ruby-1.9.2-p180/lib/Ruby/site_Ruby/1.9.1/rubygems/custom_require.rb:58:in `rescue in require'
from /home/app/.rvm/rubies/Ruby-1.9.2-p180/lib/Ruby/site_Ruby/1.9.1/rubygems/custom_require.rb:35:in `require'

Спасибо

14
Addicted

В случае, если вы пишете движок, который имеет свой собственный конфигурационный файл, просто добавьте 

require 'devise'

в начале инициализатора разработки . В моем случае у меня не было требования разработки в приложении :)

Ура

15
m4risU

Проверьте ваш config/application.rb, вам нужно добавить require 'devise', и все будет в порядке.

15
Marshall Shen

Убедитесь, что вы указали Devise в своем Gemfile и запустите bundle install.

4
Luke

Я получил такую ​​ошибку, когда у меня был собственный контроллер devise для переопределения «нового» метода, чтобы сделать некоторые пользовательские вещи, и забыл использовать «супер» 

У вас есть пользовательский контроллер?

3
jpwynn

У меня была похожая проблема, и я нашел это https://github.com/plataformatec/devise

Он говорит, что вы должны сделать 

Rails generate devise:install

После "Начало работы" на этой странице я начал

2
C. Louis S.

У меня просто была эта проблема, потому что я сгенерировал модель представления по ошибке и не удалил ее из моего rout.rb

1
LiffeyD

Мне пришлось добавить require 'devise' в файл spec/spec_helper.rb, и эта ошибка исчезла.

1
cam_271

если вы больше не используете devise gem, удалите

gem 'devise'

из gemfile и удалите 

config/initializers/devise.rb 

также убедитесь, что устройство нигде не используется

1
Muhammad Aqeel

В вашем config/application.rb добавьте require 'yaml'. Меня устраивает. Пытаться

0
Андрій Душар

Я добавил несколько столбцов после установки Devise и добавил несколько проверок в свою пользовательскую модель . Из сообщения об ошибке похоже, что Rails не может найти необходимую библиотеку, поэтому не может найти Devise. Может быть, зайти на страницу Wiki разработки Github и убедиться, что все зависимости удовлетворены?

Надеюсь, поможет! 

0
Marshall Shen